/*
 * XPconstants.h
 *
 * (C 2003 ramjac Software/Patrick Enoch
 *
 * the definition of pi, e, ... goes here
 *
 * actually they are defined as double's
 * so they can be changed by the expression
 *
 * TO DO: copy/paste from calculatorinit.cpp
 */

#ifndef __XP_CONSTANTS_
#define __XP_CONSTANTS_

namespace XPconstants
{
double acres_per_sq_km = 247.1;
double air_density = 1.293;
double air_mol_mass = 0.02897;
double atm_per_psi = 0.06804;
double avogadro = 6.0220e23;
double boltzmann = 1.3807e-23;
double speed_light = 2.997925e8; // old name: c
double cm_per_in = 2.54;
double coulomb_const = 8.98755e9;
double deg_per_rad = 57.2958;
double earth_esc_spd = 1.12e4;
double earth_grav = 9.80665;
double earth_mass = 5.98e24;
double earth_radius = 6.37e6;
double earth_to_moon = 3.844e8;
double earth_to_sun = 1.496e11;
//double eps0 = 8.85419e-12;
double erg_per_joule = 1e7;
double eulers_const = 0.57721566490153286061;
//double false = false;
double ft_per_m = 3.280839895;
//double g = 6.672e-11;
double gas_const = 8.314;
double gauss_per_tesla = 1e4;
double gm_per_oz = 28.34952313;
double golden_ratio = 1.6180339887498948482;
//double h = 6.6262e-34;
double hbar = 1.05459e-34;
double joule_per_btu = 1054.35;
double joule_per_cal = 4.184;
double joule_per_ftlb = 1.356;
double joule_per_kwh = 3.6e6;
double kg_per_slug = 14.59;
double km_per_mi = 1.609344;
double knots_per_mph = 0.86897624;
double lbs_per_kg = 2.204622622;
double lit_per_gal = 3.785411784;
//double me = 9.1095e-31;
//double mn = 1.67495e-27;
double moon_grav = 1.62;
double moon_mass = 7.35e22;
double moon_period = 2360448;
double moon_radius = 1.738e6;
//double mp = 1.67265e-27;
//double mu0 = 1.256637e-6;
double oz_per_gal = 128;
double pasc_per_atm = 101325;
double pasc_per_psi = 6895;
double pasc_per_torr = 133.32;
//double qe = 1.60219e-19;
double solar_const = 1350;
double speed_sound = 331;
double sun_mass = 1.99e30;
double sun_radius = 6.98e8;
//double true = true;
double watts_per_hp = 745.712;
double zero_deg_cels = 273.15;
};

using namespace XPconstants;

#endif
