/*
 *		XPfunctionstrig.h
 *
 *	(C) 2003 ramjac Software/Patrick Enoch
 *
 *	we provide a frontend to the trig. functions
 *	(EIU uses 0..360 degrees, mathlib uses 0..2*pi rad)
 */
#ifndef __XP_FUNCTIONSTRIG_
#define __XP_FUNCTIONSTRIG_

/*
 *	the frontend is defined XPfunctionstrig.cpp
 *	here: just link the functions in
 */
extern double _sin(double);
extern double _sinh(double);
extern double _asin(double);
extern double _cos(double);
extern double _cosh(double);
extern double _acos(double);
extern double _tan(double);
extern double _tanh(double);
extern double _atan(double);

inline double cos(double x) 	{ return _cos(x); 	}
inline double cosh(double x) 	{ return _cosh(x); 	}
inline double acos(double x) 	{ return _acos(x); 	}

inline double sin(double x) 	{ return _sin(x); 	}
inline double sinh(double x) 	{ return _sinh(x); 	}
inline double asin(double x) 	{ return _asin(x);	}

inline double tan(double x) 	{ return _tan(x); 	}
inline double tanh(double x) 	{ return _tanh(x); 	}
inline double atan(double x) 	{ return _atan(x); 	}

/*
 *	define the original trig. functions in case somebody needs them
 */
extern double _origsin(double);
extern double _origcos(double);
extern double _origtan(double);

#endif
