/*
 *		XPinternal.h
 *
 *	(C) 2003 ramjac Software/Patrick Enoch
 *
 *	internal structures of Xpressionist passed to the expression-program
 */
#ifndef __XP_INTERNAL_
#define __XP_INTERNAL_

/*
 *	some useful apple-typical types
 *	which hopefully do not collide with any system-types
 */
typedef char*				Ptr;
typedef unsigned char       UInt8;
typedef signed char         SInt8;
typedef unsigned short      UInt16;
typedef signed short        SInt16;
typedef unsigned long       UInt32;
typedef signed long         SInt32;
typedef unsigned char 		PStr255[256];
typedef unsigned char 		PStr127[127];
typedef unsigned char 		PStr63[64];
typedef unsigned char 		PStr31[32];
typedef unsigned char       Boolean;

/*
 *	internal XPressionist structures
 */
typedef char* PluginInfoPtr;
typedef char* PluginDataPtr;

/*
 *	an indexable variable must know this structure to identify itself to XPressionist
 */
typedef struct ChannelIDRec 
{
	long			channelnum;
	char*			object;
} ChannelIDRec, *ChannelIDPtr;

typedef struct ChannelRec 
{	
	PStr255			variablename;	// name
	PStr63			objectname;		// name der objects
	ChannelIDRec	chanID;			// number & subchannel
	long			flags1;
	long			flags2;
							// NamedValueRec
	double			value[4];
	long			changed;
	long			type;
	long			channelType;
	void*			calcsymbol;
	char			rawbuffer[256];
} ChannelRec, *ChannelPtr;


/*
 *	this one is passed to the expression-program
 *
 *	sourceValues is a pointer to all indexable values (NamedValueRec)
 */
typedef struct CalculatorDataRec {
	long			validID1;
	long			validID2;
	PluginDataPtr	theData;
	long			countSource;
	ChannelPtr		sourceValues;
	void**			IndexedVariableDLL;
	void**			AddLineDLL;
	void**			AddFacetDLL;
	long			forkOff;
	long			result;
	Ptr				expression;
	unsigned long	expression_size;
	long			frame;
	double			fps;
	double			time;
	long			childGroups;
	long			generateGeometry;
	void*			IndexedVariableCallback;
	void*			ErrorCallback;
	void*			AddFacetCallback;
	void*			ChildModifierCallback;
	void*			AddCharacterCallback;
	void*			AbsPositionCallback;
	long			synchedToFrame;
	void*			AddLineCallback;
	long			IsCamera;
	long			strictSyntax;
	void**			FindObjectDLL;
	double			startTime;
	long			totalFrames;
} CalculatorDataRec,*CalculatorDataPtr;

#endif
