/*
 *		XPstring.h
 *
 *	(C) 2003 ramjac Software/Patrick Enoch
 *
 *	includes <string> and defines it for the expression
 */
#ifndef __XP_OBJECT_
#define __XP_OBJECT_

#include "XPinternal.h"
#include "XPindexed_types.h"

#include <string>

void XPinternal_findObject(const char objname[], char*&object, long& type);

typedef class XPinternal_rawobject
{
public:
	string			objectname;
	Ptr				objectptr;
	long			objecttype;
	
	ChannelPtr		sourcevalue;
}XPinternal_rawobject;

typedef class XPinternal_rawchannelfloat
{
public:
virtual void init(XPinternal_rawobject * masterobj, long num)
		{
			master = masterobj;
			channelnum = num;
		}


virtual operator double()
		{
			return 0.0;
		}
XPinternal_rawchannelfloat& operator =(double a)
		{
		}

private:
	XPinternal_rawobject* master;
	long channelnum;
	double value;
}XPinternal_rawchannelfloat;


typedef class XPinternal_rawchannelvec
{
public:
virtual void init(XPinternal_rawobject * masterobj, long num)
		{
			master = masterobj;
			channelnum = num;
		}


virtual operator double()
		{
			return 0.0;
		}

XPinternal_rawchannelvec& operator =(vec a)
		{
		}

private:
	XPinternal_rawobject* master;
	long channelnum;
	double value;
}XPinternal_rawchannelvec;


typedef class object : public XPinternal_rawobject
{
public:
		object()
		{
			init_channels();
			objectname="";
			objectptr=0;
			objecttype=0;
		};
		
		object(string a)
		{
			init_channels();
			objectname = a;
			XPinternal_findObject(objectname.c_str(), objectptr, objecttype);
		};
		
object& operator = (string a)
		{
			objectname = a;
			XPinternal_findObject(objectname.c_str(), objectptr, objecttype);
		}
		
		XPinternal_rawchannelfloat Visibility;
		XPinternal_rawchannelvec Position;

private:

virtual void init_channels()
		{
			Visibility.init((XPinternal_rawobject*)this,100);
			Position.init((XPinternal_rawobject*)this,101);
		}
		
}object;


#endif
