/*
 *		XPprefix.h
 *
 *	(C) 2003 ramjac Software/Patrick Enoch
 *
 *	This file is included at the beginning of every expression.cpp
 *
 *	An expression.cpp looks like this:
 *
 *	#include "XPprefix.h"
 *
 *	load values for sceneobject-variables
 *	execute expression (converted to pure c++)
 *	save values for sceneobject-variables
 *
 *	#include "XPsuffix.h"
 *
 */

// if anything changed here, be sure to change it in XPfunctionprefix.h
#include "XPinternal.h"
#include "XPdebug.h"
#include "XPmath.h"
#include "XPstring.h"
#include "XPvec.h"
#include "XPvec4.h"
#include "XPindexed_types.h"
#include "XPfunctions.h"
#include "XPconstants.h"
#include "XPobject.h"

#include <signal.h>
#include <unistd.h>
//#include <syslog.h>

/*
 *	some global "constants"
 */
CalculatorDataPtr xpression_data;
double	iscamera;
double	isanimator;
double	frame;
double	fps;
//double	time;
double	childgroups;
int 	xpression_result;

/*
 *	this routine is called by XPressionist
 */
extern "C" void xpression(CalculatorDataPtr xpression__data);
extern "C" void xpression(CalculatorDataPtr xpression__data)
{
/*
 *	check some magic values
 */
	if (xpression__data == 0)
	{
		return;
	};
	if (xpression__data->validID1 != 0x12345678)
	{
		return;
	};
	if (xpression__data->validID2 != 0x87654321)
	{
		return;
	};
	xpression_data = xpression__data;

/*
 *	set global "constants" from the xpression-data
 */
iscamera=xpression_data->IsCamera;
isanimator=!xpression_data->IsCamera;
frame=xpression_data->frame;
fps=xpression_data->fps;
double time=xpression_data->time;
childgroups=xpression_data->childGroups;

/*
 *	default result is 0 (no err)
 */
xpression_result=0;

/*
 *	default return value is 1 (expression started)
 */
xpression_data->result=1;

/*
 *	print initial values:
 */
XPdebug_printf("--------------- frame %1.0f\n", frame);
XPdebug_printf("sources %d\n", xpression_data->countSource);
for (long XPi=0; XPi<xpression_data->countSource; XPi++)
{
	switch (xpression_data->sourceValues[XPi].type)
	{
		case 1:
			XPdebug_printf("float( %f )\n", xpression_data->sourceValues[XPi].value[0] );
			break;

		case 2:
			XPdebug_printf("vec( %f,%f,%f )\n", xpression_data->sourceValues[XPi].value[0],
										xpression_data->sourceValues[XPi].value[1],
										xpression_data->sourceValues[XPi].value[2] );
			break;

		case 3:
			XPdebug_printf("vec4( %f,%f,%f,%f )\n", xpression_data->sourceValues[XPi].value[0],
										xpression_data->sourceValues[XPi].value[1],
										xpression_data->sourceValues[XPi].value[2],
										xpression_data->sourceValues[XPi].value[3] );
			break;

		default:
			XPdebug_printf("type %d\n", xpression_data->sourceValues[XPi].type );
	}
}

/*
 *	expression starts here:
 */

